<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatsInArea ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatsInArea
 * @subpackage Arrays
 */
class ArrayOfSeatsInArea extends AbstractStructArrayBase
{
    /**
     * The SeatsInArea
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \patest\StructType\SeatsInArea[]
     */
    public $SeatsInArea;
    /**
     * Constructor method for ArrayOfSeatsInArea
     * @uses ArrayOfSeatsInArea::setSeatsInArea()
     * @param \patest\StructType\SeatsInArea[] $seatsInArea
     */
    public function __construct(array $seatsInArea = array())
    {
        $this
            ->setSeatsInArea($seatsInArea);
    }
    /**
     * Get SeatsInArea value
     * @return \patest\StructType\SeatsInArea[]|null
     */
    public function getSeatsInArea()
    {
        return $this->SeatsInArea;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatsInArea method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatsInArea method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatsInAreaForArrayConstraintsFromSetSeatsInArea(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatsInAreaSeatsInAreaItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatsInAreaSeatsInAreaItem instanceof \patest\StructType\SeatsInArea) {
                $invalidValues[] = is_object($arrayOfSeatsInAreaSeatsInAreaItem) ? get_class($arrayOfSeatsInAreaSeatsInAreaItem) : sprintf('%s(%s)', gettype($arrayOfSeatsInAreaSeatsInAreaItem), var_export($arrayOfSeatsInAreaSeatsInAreaItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatsInArea property can only contain items of type \patest\StructType\SeatsInArea, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatsInArea value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\SeatsInArea[] $seatsInArea
     * @return \patest\ArrayType\ArrayOfSeatsInArea
     */
    public function setSeatsInArea(array $seatsInArea = array())
    {
        // validation for constraint: array
        if ('' !== ($seatsInAreaArrayErrorMessage = self::validateSeatsInAreaForArrayConstraintsFromSetSeatsInArea($seatsInArea))) {
            throw new \InvalidArgumentException($seatsInAreaArrayErrorMessage, __LINE__);
        }
        $this->SeatsInArea = $seatsInArea;
        return $this;
    }
    /**
     * Add item to SeatsInArea value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\SeatsInArea $item
     * @return \patest\ArrayType\ArrayOfSeatsInArea
     */
    public function addToSeatsInArea(\patest\StructType\SeatsInArea $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\SeatsInArea) {
            throw new \InvalidArgumentException(sprintf('The SeatsInArea property can only contain items of type \patest\StructType\SeatsInArea, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatsInArea[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\SeatsInArea|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\SeatsInArea|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\SeatsInArea|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\SeatsInArea|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\SeatsInArea|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatsInArea
     */
    public function getAttributeName()
    {
        return 'SeatsInArea';
    }
}
